HDU 4283:You Are the One(区间DP)

来源:互联网 发布:sql server约束 编辑:程序博客网 时间:2024/06/05 19:24

You Are the One

Time limit:1000 ms Memory limit:32768 kB


Problem Description

 The TV shows such as You Are the One has been very popular. In order to meet the need of boys who are still single, TJUT hold the show itself. The show is hold in the Small hall, so it attract a lot of boys and girls. Now there are n boys enrolling in. At the beginning, the n boys stand in a row and go to the stage one by one. However, the director suddenly knows that very boy has a value of diaosi D, if the boy is k-th one go to the stage, the unhappiness of him will be (k-1)*D, because he has to wait for (k-1) people. Luckily, there is a dark room in the Small hall, so the director can put the boy into the dark room temporarily and let the boys behind his go to stage before him. For the dark room is very narrow, the boy who first get into dark room has to leave last. The director wants to change the order of boys by the dark room, so the summary of unhappiness will be least. Can you help him? 

Input

    The first line contains a single integer T, the number of test cases.  For each case, the first line is n (0 < n <= 100)   The next n line are n integer D1-Dn means the value of diaosi of boys (0 <= Di <= 100) 

Output

For each test case, output the least summary of unhappiness . 

Sample Input

251 2 3 4 555 4 3 2 2

Sample Output

Case #1: 20Case #2: 24

题意:

有n个男孩,安排出场次序,每个男孩都有一个愤怒值,设为ai,第k个上场的男孩愤怒值则为(k-1)*ai,要我们合理安排出场次序,使得总的愤怒值最小

解题思路:

dp[i][j]表示从第i个人到第j个人这段区间的最小花费(是只考虑这j-i+1个人,不需要考虑前面有多少人)
那么对于[i,j]中的第1个人,就有可能第1个上场,也可以第j-i+1个上场。
考虑第K个上场即在i+1之后的K-1个人是率先上场的,那么就出现了一个子问题 dp[i+1][i+1+k-1-1]表示在第i个人之前上场的
对于第i个人,由于是第k个上场的,那么愤怒值便是val[i]*(k-1)其余的人是排在第k+1个之后出场的,也就是一个子问题dp[i+k][j],对于这个区间的人,由于排在第k+1个之后,所以整体愤怒值要加上k(ji+k)


Code:

#include <iostream>#include <cstring>#include <algorithm>#include <cstdio>#define mem(a,b) memset(a,b,sizeof(a))using namespace std;const int maxn=105;int a[maxn];int sum[maxn];int dp[maxn][maxn];int DFS(int i,int j){    if(dp[i][j]!=0)        return dp[i][j];    if(i>=j)        return 0;    int ans=1e9;    for(int k=i;k<=j;k++)    {        ans=min(ans,DFS(i+1,k)+DFS(k+1,j)+(k-i+1)*(sum[j]-sum[k])+a[i]*(k-i));    }    dp[i][j]=ans;    //printf("dp[%d][%d]:%d\n",i,j,ans);    return ans;}int main(){    int T;    scanf("%d",&T);    for(int ca=1;ca<=T;ca++)    {        mem(sum,0);        mem(dp,0);        int n;        scanf("%d",&n);        for(int i=1;i<=n;i++)        {            scanf("%d",a+i);            sum[i]=sum[i-1]+a[i];        }        printf("Case #%d: %d\n",ca,DFS(1,n));    }    return 0;}
原创粉丝点击